﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WPFValidationRules
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            var person = new Person();
            person.Name = "Test";

            this.DataContext = person;
        }
    }

    public class Person
    {
        public string Name { get; set; }

        public int Age { get; set; }
    }

    /// <summary>
    /// Require 验证
    /// </summary>
    public class RequiredRule : ValidationRule
    {
        public override ValidationResult Validate(object value, CultureInfo cultureInfo)
        {
            if (value == null)
                return new ValidationResult(false, "不能为空值！");
            if (string.IsNullOrEmpty(value.ToString()))
                return new ValidationResult(false, "不能为空字符串！");

            return new ValidationResult(true, null);
        }
    }

    public class GreaterThanRule : ValidationRule
    {
        public int? Number { get; set; }

        public override ValidationResult Validate(object value, CultureInfo cultureInfo)
        {
            if (value == null || Number == null)
            {
                return new ValidationResult(false, "请输入比较的值，且比较的值不能为空");
            }

            int v;
            if (!int.TryParse(value.ToString(), out v))
                return new ValidationResult(false, "请输入数字");

            return v > Number
                       ? new ValidationResult(true, null)
                       : new ValidationResult(false, string.Format("{0}必需小于{1}", v, Number));
        }
    }

}
